typedef unsigned char   u8;
typedef signed char     s8;
typedef unsigned int    u16;
typedef signed int      s16;
typedef unsigned long   u32;
typedef signed long     s32;

//#define debug

#define cpu_speed (u32)8E6
#define pwm_freq  0xffff

#define RFB         510000UL          //Ohms
#define RTG         4700              //Ohms
#define K_PAIR      41                //uV
#define ADCMAX      2560UL            //mV
#define K_AMPLIFIER (100+RFB*100/RTG) //LM358 amplification 109.57*100  121
#define MAXTC       (ADCMAX*1000*100/K_PAIR*100/K_AMPLIFIER)//569.85*100
#define AMBIENT     20                //C
#define OFFSET      (26UL*K_AMPLIFIER/100*MAXTC/ADCMAX/10)  //63.41*100    
#define CPADC       (MAXTC/0x3ff)     //     *100  ~0.55*100
#define R_IRN       12                //   *10,  

struct my_structure 
{
 u16 k_amplifier;
 u16 maxtc;
 u16 offset;
 u16 cpadc; 
 u16 r_irn;
};


#define CO 3

#define A   PORTD.4
#define B   PORTD.3
#define C   PORTD.2
#define D   PORTD.1
#define E   PORTD.0
#define F   PORTC.4
#define G   PORTC.3
#define DP  PORTC.2

#define N00      PORTD.6
#define N00_ddr  DDRD.6
#define IDR0     PIND.6
#define N01      PORTB.0
#define N01_ddr  DDRB.0
#define N0       N00=N01
#define DDR0     N00_ddr=N01_ddr

#define N10      PORTD.5
#define N10_ddr  DDRD.5
#define N11      PORTB.3
#define N11_ddr  DDRB.3
#define N1       N10=N11
#define DDR1     N10_ddr=N11_ddr

#define N20      PORTB.7
#define N20_ddr  DDRB.7
#define N21      PORTB.6
#define N21_ddr  DDRB.6
#define N2       N20=N21
#define DDR2     N20_ddr=N21_ddr

#define PWM_OFF do{TCCR1A=0;}while(0)
#define PWM_ON  do{TCCR1A=1<<COM1A1|1<<COM1A0|1<<COM1B1;}while(0)


#define infinitely() for(;;)